<template>
  <div>
    <h1>
      {{ $t('sidebar.clansRank.title')}}
    </h1>
    <div class="has-text-centered is-uppercase">
      <b-radio v-model="mode"
          name="mode"
          size="is-small"
          native-value="attack">
          {{ $t('sidebar.clansRank.attackRadioLabel') }}
      </b-radio>
      <b-radio v-model="mode"
          name="mode"
          size="is-small"
          native-value="mission">
          {{ $t('sidebar.clansRank.missionRadioLabel') }}
      </b-radio>
    </div>
    <div class="has-text-centered">
      <ul>
        <li v-for="(clan, index) in ranking" :key="clan.id">
          {{ index + 1 }}.
          <router-link :to="{ name: 'clan', params: { id: clan.id } }"
                        class="has-text-weight-semibold">
            {{ clan.name }}
          </router-link>
          {{ clan.points }}
        </li>
      </ul>
      <router-link :to="{ name: 'RankingClan' }"
                   class="is-capitalized">
        {{ $t('sidebar.clansRank.fullRankings') }}
      </router-link>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';

enum ClanMode {
  attack = 'attack',
  mission = 'mission',
}

interface Clan {
  name: string;
  points: number;
  id: string;
}

@Component
export default class ClansRank extends Vue {
  mode: ClanMode = ClanMode.attack;
  attackRanking: Clan[] = [
    { name: 'ABSYNTHEUS', points: 254, id: '1' },
    { name: 'FISHERMAN', points: 171, id: '2' },
    { name: 'Happy Lover', points: 160, id: '3' },
  ];
  missionRanking: Clan[] = [
    { name: 'Happy Lover', points: 1160, id: '3' },
    { name: 'FISHERMAN', points: 371, id: '2' },
    { name: 'ABSYNTHEUS', points: 254, id: '1' },
  ];

  get ranking(): Clan[] {
    return this[this.mode + 'Ranking'];
  }
}
</script>
